package net.shadowfacts.phycon.api;

import net.shadowfacts.phycon.api.util.IPAddress;
import org.jetbrains.annotations.NotNull;

/**
 * @author shadowfacts
 */
public interface NetworkDevice {

	/**
	 * The IP address of this device.
	 *
	 * If a device has not been assigned an address by a DHCP server, it may self-assign a randomly generated one.
	 *
	 * The address of a network device should never be the broadcast address.
	 *
	 * @return The IP address of this device.
	 */
	@NotNull
	IPAddress getIPAddress();

}
